From 627decfea2ad731dc6ebec13ad7c94a01752b1c8 Mon Sep 17 00:00:00 2001
From: Peter Geoghegan <pg@bowt.ie>
Date: Thu, 9 Jan 2025 11:51:28 -0500
Subject: [PATCH v1] Move nbtree preprocessing into new .c file.

---
 src/include/access/nbtree.h                   |   11 +-
 src/backend/access/nbtree/Makefile            |    1 +
 src/backend/access/nbtree/meson.build         |    1 +
 src/backend/access/nbtree/nbtpreprocesskeys.c | 1864 +++++++++++++++++
 src/backend/access/nbtree/nbtutils.c          | 1860 +---------------
 5 files changed, 1878 insertions(+), 1859 deletions(-)
 create mode 100644 src/backend/access/nbtree/nbtpreprocesskeys.c

diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index b88bd4435..8dcfe5674 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -1260,6 +1260,11 @@ extern void _bt_pendingfsm_init(Relation rel, BTVacState *vstate,
 								bool cleanuponly);
 extern void _bt_pendingfsm_finalize(Relation rel, BTVacState *vstate);
 
+/*
+ * prototypes for functions in nbtpreprocesskeys.c
+ */
+extern void _bt_preprocess_keys(IndexScanDesc scan);
+
 /*
  * prototypes for functions in nbtsearch.c
  */
@@ -1277,8 +1282,12 @@ extern Buffer _bt_get_endpoint(Relation rel, uint32 level, bool rightmost);
 extern BTScanInsert _bt_mkscankey(Relation rel, IndexTuple itup);
 extern void _bt_freestack(BTStack stack);
 extern bool _bt_start_prim_scan(IndexScanDesc scan, ScanDirection dir);
+extern int	_bt_binsrch_array_skey(FmgrInfo *orderproc,
+								   bool cur_elem_trig, ScanDirection dir,
+								   Datum tupdatum, bool tupnull,
+								   BTArrayKeyInfo *array, ScanKey cur,
+								   int32 *set_elem_result);
 extern void _bt_start_array_keys(IndexScanDesc scan, ScanDirection dir);
-extern void _bt_preprocess_keys(IndexScanDesc scan);
 extern bool _bt_checkkeys(IndexScanDesc scan, BTReadPageState *pstate, bool arrayKeys,
 						  IndexTuple tuple, int tupnatts);
 extern bool _bt_oppodir_checkkeys(IndexScanDesc scan, ScanDirection dir,
diff --git a/src/backend/access/nbtree/Makefile b/src/backend/access/nbtree/Makefile
index d69808e78..c5cd4e017 100644
--- a/src/backend/access/nbtree/Makefile
+++ b/src/backend/access/nbtree/Makefile
@@ -17,6 +17,7 @@ OBJS = \
 	nbtdedup.o \
 	nbtinsert.o \
 	nbtpage.o \
+	nbtpreprocesskeys.o \
 	nbtree.o \
 	nbtsearch.o \
 	nbtsort.o \
diff --git a/src/backend/access/nbtree/meson.build b/src/backend/access/nbtree/meson.build
index 177255524..80962de6e 100644
--- a/src/backend/access/nbtree/meson.build
+++ b/src/backend/access/nbtree/meson.build
@@ -5,6 +5,7 @@ backend_sources += files(
   'nbtdedup.c',
   'nbtinsert.c',
   'nbtpage.c',
+  'nbtpreprocesskeys.c',
   'nbtree.c',
   'nbtsearch.c',
   'nbtsort.c',
